<?php 
/* 
Plugin Name: Goo.gl Generator
Plugin URI: http://www.dolcebita.com/wordpress/googl-generator/
Description: Returns short URL based on Goo.gl using Matthew Flaschen web service.
Version: 0.6
Author: Marcos Esperon
Author URI: http://www.dolcebita.com/
*/

/*  Copyright 2010  Marcos Esperon

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; 
*/

function gg_get_short_url($long_url) {
  
  $short_url = $long_url;
  
  if (extension_loaded("curl")) {
  
    $curl = curl_init("http://ggl-shortener.appspot.com/?url=" . rawurlencode($long_url));
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    $response_text = curl_exec($curl);
    if($response_text) {
      $json_response = json_decode($response_text);
    }
    $short_url = $json_response->short_url;
  
  } else {
  
    $url = htmlentities($long_url, ENT_QUOTES);
    $obj = json_decode(file_get_contents('http://ggl-shortener.appspot.com/?url=' . urlencode($url)));
    $short_url = $obj->{'short_url'};

  }
  
  return $short_url;
  
}

function gg_generate($long_url, $short_url) {
	
  $output = '<div class="google_generator">';
  
  if($short_url == '') $short_url = gg_get_short_url($long_url);
  
  if(get_option('gg_version') == 'link') {
    $output .= '<a href="'.$short_url.'" title="Short URL">'.$short_url.'</a>';
  } else if (get_option('gg_version') == 'input') {
    $output .= '<input type="text" value="'.$short_url.'" readonly />';
  } else if (get_option('gg_version') == 'qrcode') {
    $output .= '<img src="'.$short_url.'.qr" alt="QRCode" />';
  } else {
    $output .= $short_url;
  }
  
  $output .= '</div>';
  return $output;
  
}

function googl_generator($long_url, $short_url) {
  echo gg_generate($long_url, $short_url);
}

function googl_generator_box($content) {

    global $post;
    

    if (get_option('gg_display_post') == null && is_single()) {
        return $content;
    }
    
    if (get_option('gg_display_page') == null && is_page()) {
        return $content;
    }

    if (get_option('gg_display_front') == null && is_home()) {
        return $content;
    }
    
    if (get_option('gg_display_feed') == null && is_feed()) {
        return $content;
    }
		
    $url = '';
    if (get_post_status($post->ID) == 'publish') {
        $url = get_permalink();
        $short_url = get_post_meta($post->ID, 'googl_short_url', true);
    }
    $box = gg_generate($url, $short_url);
    
    // Before and After code added by http://www.jimyaghi.com
    if (get_option('gg_where') == 'beforeandafter') {
      return $box . $content . $box;
    } else if (get_option('gg_where') == 'before') {
      return $box . $content;
    } else {
      return $content . $box;
    }
		
}

function gg_remove_filter($content) {
	if (!is_feed()) {
    	remove_action('the_content', 'googl_generator_box');
	}
    return $content;
}

function gg_options_page() {
?>
    <div class="wrap">
    <div class="icon32" id="icon-options-general"><br/></div><h2>Settings for Goo.gl Generator</h2>
    <form method="post" action="options.php">
    <?php
        // New way of setting the fields, for WP 2.7 and newer
        if(function_exists('settings_fields')){
            settings_fields('gg-options');
        } else {
            wp_nonce_field('update-options');
            ?>
            <input type="hidden" name="action" value="update" />
            <input type="hidden" name="page_options" value="gg_where,gg_display_page,gg_display_post,gg_display_front,gg_display_feed,gg_version" />
            <?php
        }
    ?>
        <table class="form-table">
            <tr>
	            <tr>
	                <th scope="row">
	                    Display
	                </th>
	                <td>
	                    <p>
	                        <input type="checkbox" value="1" <?php if (get_option('gg_display_post') == '1') echo 'checked="checked"'; ?> name="gg_display_post" id="gg_display_post" group="gg_display"/>
	                        <label for="gg_display_post">Display the URL on posts</label>
	                    <br />
	                        <input type="checkbox" value="1" <?php if (get_option('gg_display_page') == '1') echo 'checked="checked"'; ?> name="gg_display_page" id="gg_display_page" group="gg_display"/>
	                        <label for="gg_display_page">Display the URL on pages</label>
	                    <br />
	                        <input type="checkbox" value="1" <?php if (get_option('gg_display_front') == '1') echo 'checked="checked"'; ?> name="gg_display_front" id="gg_display_front" group="gg_display"/>
	                        <label for="gg_display_front">Display the URL on the front page (home)</label>
                      <br />
	                        <input type="checkbox" value="1" <?php if (get_option('gg_display_feed') == '1') echo 'checked="checked"'; ?> name="gg_display_feed" id="gg_display_feed" group="gg_display"/>
	                        <label for="gg_display_feed">Display the URL on the feed (RSS)</label>
                      </p>
	                </td>
	            </tr>
                <th scope="row">
                    Position
                </th>
                <td>
                	<p>
                		<select name="gg_where">
                			<option <?php if (get_option('gg_where') == 'before') echo 'selected="selected"'; ?> value="before">Before</option>
                			<option <?php if (get_option('gg_where') == 'after') echo 'selected="selected"'; ?> value="after">After</option>
                			<option <?php if (get_option('gg_where') == 'beforeandafter') echo 'selected="selected"'; ?> value="beforeandafter">Before and After</option>
                		</select>
                	</p>
                </td>
            </tr>            
            <tr>
                <th scope="row">
                    Type
                </th>
                <td>
                    <p>
                        <input type="radio" value="plain" <?php if (get_option('gg_version') == 'plain') echo 'checked="checked"'; ?> name="gg_version" id="gg_version_plain" group="gg_version"/>
                        <label for="gg_version_plain">Text plain</label>
                    </p>
                    <p>
                        <input type="radio" value="link" <?php if (get_option('gg_version') == 'link') echo 'checked="checked"'; ?> name="gg_version" id="gg_version_link" group="gg_version"/>
                        <label for="gg_version_link">Link</label>
                    </p>
                    <p>
                        <input type="radio" value="input" <?php if (get_option('gg_version') == 'input') echo 'checked="checked"'; ?> name="gg_version" id="gg_version_input" group="gg_version" />
                        <label for="gg_version_input">Input</label>
                    </p>
                    <p>
                        <input type="radio" value="qrcode" <?php if (get_option('gg_version') == 'qrcode') echo 'checked="checked"'; ?> name="gg_version" id="gg_version_qrcode" group="gg_version" />
                        <label for="gg_version_qrcode">QR Code</label>
                    </p>
                </td>
            </tr>
        </table>
        <p class="submit">
            <input type="submit" name="Submit" value="<?php _e('Save Changes') ?>" />
        </p>
    </form>
    </div>
<?php
}

function gg_hook_publish_post($post_id, $retry = 0) {
    
    if ($retry > 10) return;
    
    $post = get_post($post_id);
    $long_url = get_permalink($post);
    
    if (get_post_meta($post_id, '_googl_long_url', true) != $long_url) {
        $short_url = gg_get_short_url($long_url);
        if (substr($short_url, 0, 5) == 'Error') {
            wp_schedule_single_event(time() + 601, 'googl_retry_shorten_url', array($post_id, $retry + 1));
        } else {
            update_post_meta($post_id, '_googl_long_url', $long_url);
            update_post_meta($post_id, 'googl_short_url', $short_url);
        }
    }
}

function gg_init(){
    if(function_exists('register_setting')){
        register_setting('gg-options', 'gg_display_page');
        register_setting('gg-options', 'gg_display_post');
        register_setting('gg-options', 'gg_display_front');
        register_setting('gg-options', 'gg_display_feed');
        register_setting('gg-options', 'gg_version');
        register_setting('gg-options', 'gg_where');        
    }
}

if(is_admin()){
    add_action('admin_init', 'gg_init');
    add_action('admin_menu', 'gg_option_page');
}

// Set the default options when the plugin is activated
function gg_activate(){
    add_option('gg_where', 'after');    
    add_option('gg_version', 'plain');    
    add_option('gg_display_page', '0');
    add_option('gg_display_post', '1');
    add_option('gg_display_front', '0');
    add_option('gg_display_feed', '0');
}

function gg_option_page() {
	add_options_page(__('Goo.gl Generator', 'googl-generator'), 'Goo.gl Generator', 8, basename(__FILE__), 'gg_options_page');
}

add_filter('the_content', 'googl_generator_box');
add_filter('get_the_excerpt', 'gg_remove_filter', 9);

add_action('publish_post', 'gg_hook_publish_post');
add_action('publish_phone', 'gg_hook_publish_post');
add_action('xmlrpc_publish_post', 'gg_hook_publish_post');

add_action('googl_retry_shorten_url', 'gg_hook_publish_post');

register_activation_hook( __FILE__, 'gg_activate');

?>